From c90f8593a505a39840642a67a84cce0b20d00789 Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Mar 04 2017 08:46:52 +0000
Subject: [PATCH 779/1001] Read the database config and metadata from hubs itself


---

diff --git a/hubs/migrations/env.py b/hubs/migrations/env.py
index 058378b..7605ce5 100644
--- a/hubs/migrations/env.py
+++ b/hubs/migrations/env.py
@@ -1,8 +1,25 @@
-from __future__ import with_statement
+from __future__ import absolute_import, unicode_literals
+
 from alembic import context
-from sqlalchemy import engine_from_config, pool
+from sqlalchemy import create_engine, pool
 from logging.config import fileConfig
 
+
+import fedmsg.config
+
+fedmsg_config = fedmsg.config.load_config()
+
+
+try:
+    import hubs
+except ImportError:
+    import os, sys
+    if "hubs" not in os.listdir("."):
+        raise
+    sys.path.append(os.getcwd())
+
+from hubs.models import BASE
+
 # this is the Alembic Config object, which provides
 # access to the values within the .ini file in use.
 config = context.config
@@ -11,11 +28,8 @@ config = context.config
 # This line sets up loggers basically.
 fileConfig(config.config_file_name)
 
-# add your model's MetaData object here
-# for 'autogenerate' support
-# from myapp import mymodel
-# target_metadata = mymodel.Base.metadata
-target_metadata = None
+url = fedmsg_config['hubs.sqlalchemy.uri']
+target_metadata = BASE.metadata
 
 # other values from the config, defined by the needs of env.py,
 # can be acquired:
@@ -35,7 +49,6 @@ def run_migrations_offline():
     script output.
 
     """
-    url = config.get_main_option("sqlalchemy.url")
     context.configure(
         url=url, target_metadata=target_metadata, literal_binds=True)
 
@@ -50,11 +63,7 @@ def run_migrations_online():
     and associate a connection with the context.
 
     """
-    connectable = engine_from_config(
-        config.get_section(config.config_ini_section),
-        prefix='sqlalchemy.',
-        poolclass=pool.NullPool)
-
+    connectable = create_engine(url, poolclass=pool.NullPool)
     with connectable.connect() as connection:
         context.configure(
             connection=connection,

